#ifndef GST_GLSHADER_VARIABLES
#define GST_GLSHADER_VARIABLES


#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define VALID_VARNAME_CHARS "abcdefghijklmnopqurstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_"

#define trimleft(s,chars) while(s[0] && strchr(chars,s[0])) ++s;
#define trimright(s,chars) { \
	char *end; \
	end=s+strlen(s)-1; \
	while(end>=s && strchr(chars,end[0])) (end--)[0]=0; \
}

char *datatype[]={
	"bool",
	"int",
	"uint",
	"float",
	"vec2",
	"vec3",
	"vec4",
	"bvec2",
	"bvec3",
	"bvec4",
	"ivec2",
	"ivec3",
	"ivec4",
	"uvec2",
	"uvec3",
	"uvec4",
	"mat2",
	"mat3",
	"mat4",
	"mat2x2",
	"mat2x3",
	"mat2x4",
	"mat3x2",
	"mat3x3",
	"mat3x4",
	"mat4x2",
	"mat4x3",
	"mat4x4",
	0
};

typedef enum {
	_bool,
	_int,
	_uint,
	_float,
	_vec2,
	_vec3,
	_vec4,
	_bvec2,
	_bvec3,
	_bvec4,
	_ivec2,
	_ivec3,
	_ivec4,
	_uvec2,
	_uvec3,
	_uvec4,
	_mat2,
	_mat3,
	_mat4,
	_mat2x2,
	_mat2x3,
	_mat2x4,
	_mat3x2,
	_mat3x3,
	_mat3x4,
	_mat4x2,
	_mat4x3,
	_mat4x4,
	_datatypecount
} datatypeindex;

typedef struct variable_desc {
	datatypeindex	type;
	char		*name;
	int		arraysize;
	int		count;
	void		*value;

} variables_desc;

char *vec_parsevalue(int n,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *bvec_parsevalue(int n,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *ivec_parsevalue(int n,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *uvec_parsevalue(int n,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *mat_parsevalue(int n, int m,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *parsevalue(GstGLShader shader,char *vartype,char *varname,int arraysize,char *value,char *_saveptr,struct variable_desc *ret);
char *parsename(char **varname,int *arraysize,char **saveptr);
int gst_gl_shadervariables_parse(GstGLShader *shader,char *variables);
void gst_gl_shadervariables_cache_delete(char *variables);

#endif
